
<!DOCTYPE html>


<html lang="en" data-content_root="../../" >

  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="viewport" content="width=device-width, initial-scale=1" />

    <title>Aidge demonstration &#8212; Eclipse Aidge  documentation</title>
  
  
  
  <script data-cfasync="false">
    document.documentElement.dataset.mode = localStorage.getItem("mode") || "";
    document.documentElement.dataset.theme = localStorage.getItem("theme") || "";
  </script>
  <!--
    this give us a css class that will be invisible only if js is disabled
  -->
  <noscript>
    <style>
      .pst-js-only { display: none !important; }

    </style>
  </noscript>
  
  <!-- Loaded before other Sphinx assets -->
  <link href="../../_static/styles/theme.css?digest=8878045cc6db502f8baf" rel="stylesheet" />
<link href="../../_static/styles/pydata-sphinx-theme.css?digest=8878045cc6db502f8baf" rel="stylesheet" />

    <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=8f2a1f02" />
    <link rel="stylesheet" type="text/css" href="../../_static/graphviz.css?v=4ae1632d" />
    <link rel="stylesheet" type="text/css" href="../../_static/copybutton.css?v=76b2166b" />
    <link rel="stylesheet" type="text/css" href="../../_static/sg_gallery.css?v=d2d258e8" />
    <link rel="stylesheet" type="text/css" href="../../_static/sphinx-design.min.css?v=95c83b7e" />
    <link rel="stylesheet" type="text/css" href="../../_static/nbsphinx-code-cells.css?v=2aa19091" />
    <link rel="stylesheet" type="text/css" href="../../_static/css/custom.css?v=794b2ffd" />
  
  <!-- So that users can add custom icons -->
  <script src="../../_static/scripts/fontawesome.js?digest=8878045cc6db502f8baf"></script>
  <!-- Pre-loaded scripts that we'll load fully later -->
  <link rel="preload" as="script" href="../../_static/scripts/bootstrap.js?digest=8878045cc6db502f8baf" />
<link rel="preload" as="script" href="../../_static/scripts/pydata-sphinx-theme.js?digest=8878045cc6db502f8baf" />

    <script src="../../_static/documentation_options.js?v=5929fcd5"></script>
    <script src="../../_static/doctools.js?v=9bcbadda"></script>
    <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <script src="../../_static/clipboard.min.js?v=a7894cd8"></script>
    <script src="../../_static/copybutton.js?v=f281be69"></script>
    <script src="../../_static/design-tabs.js?v=f930bc37"></script>
    <script src="https://cdn.jsdelivr.net/npm/@jupyter-widgets/html-manager@^1.0.1/dist/embed-amd.js"></script>
    <script>window.MathJax = {"tex": {"inlineMath": [["$", "$"], ["\\(", "\\)"]], "processEscapes": true}, "options": {"ignoreHtmlClass": "tex2jax_ignore|mathjax_ignore|document", "processHtmlClass": "tex2jax_process|mathjax_process|math|output_area"}}</script>
    <script defer="defer" src="https://cdn.jsdelivr.net/npm/mathjax@3/es5/tex-mml-chtml.js"></script>
    <script>DOCUMENTATION_OPTIONS.pagename = 'source/Tutorial/101_first_step';</script>
    <script>
        DOCUMENTATION_OPTIONS.theme_version = '0.16.1';
        DOCUMENTATION_OPTIONS.theme_switcher_json_url = 'https://eclipse-aidge.readthedocs.io/en/dev/_static/version_switcher.json';
        DOCUMENTATION_OPTIONS.theme_switcher_version_match = '0.5.0';
        DOCUMENTATION_OPTIONS.show_version_warning_banner =
            false;
        </script>
    <script src="../../_static/js/mermaid.min.js"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="Database MNIST" href="database.html" />
    <link rel="prev" title="Tutorials" href="index.html" />
  <meta name="viewport" content="width=device-width, initial-scale=1"/>
  <meta name="docsearch:language" content="en"/>
  <meta name="docsearch:version" content="0.5.0" />
  </head>
  
  
  <body data-bs-spy="scroll" data-bs-target=".bd-toc-nav" data-offset="180" data-bs-root-margin="0px 0px -60%" data-default-mode="">

  
  
  <div id="pst-skip-link" class="skip-link d-print-none"><a href="#main-content">Skip to main content</a></div>
  
  <div id="pst-scroll-pixel-helper"></div>
  
  <button type="button" class="btn rounded-pill" id="pst-back-to-top">
    <i class="fa-solid fa-arrow-up"></i>Back to top</button>

  
  <dialog id="pst-search-dialog">
    
<form class="bd-search d-flex align-items-center"
      action="../../search.html"
      method="get">
  <i class="fa-solid fa-magnifying-glass"></i>
  <input type="search"
         class="form-control"
         name="q"
         placeholder="Search the docs ..."
         aria-label="Search the docs ..."
         autocomplete="off"
         autocorrect="off"
         autocapitalize="off"
         spellcheck="false"/>
  <span class="search-button__kbd-shortcut"><kbd class="kbd-shortcut__modifier">Ctrl</kbd>+<kbd>K</kbd></span>
</form>
  </dialog>

  <div class="pst-async-banner-revealer d-none">
  <aside id="bd-header-version-warning" class="d-none d-print-none" aria-label="Version warning"></aside>
</div>

  
    <header class="bd-header navbar navbar-expand-lg bd-navbar d-print-none">
<div class="bd-header__inner bd-page-width">
  <button class="pst-navbar-icon sidebar-toggle primary-toggle" aria-label="Site navigation">
    <span class="fa-solid fa-bars"></span>
  </button>
  
  
  <div class="col-lg-3 navbar-header-items__start">
    
      <div class="navbar-item">

  
    
  

<a class="navbar-brand logo" href="../../index.html">
  
  
  
  
  
    
    
      
    
    
    <img src="../../_static/Isotype-aidge.png" class="logo__image only-light" alt=""/>
    <img src="../../_static/Isotype-aidge.png" class="logo__image only-dark pst-js-only" alt=""/>
  
  
    <p class="title logo__title">Eclipse Aidge</p>
  
</a></div>
    
      <div class="navbar-item">
<div class="version-switcher__container dropdown pst-js-only">
  <button id="pst-version-switcher-button-2"
    type="button"
    class="version-switcher__button btn btn-sm dropdown-toggle"
    data-bs-toggle="dropdown"
    aria-haspopup="listbox"
    aria-controls="pst-version-switcher-list-2"
    aria-label="Version switcher list"
  >
    Choose version  <!-- this text may get changed later by javascript -->
    <span class="caret"></span>
  </button>
  <div id="pst-version-switcher-list-2"
    class="version-switcher__menu dropdown-menu list-group-flush py-0"
    role="listbox" aria-labelledby="pst-version-switcher-button-2">
    <!-- dropdown will be populated by javascript on page load -->
  </div>
</div></div>
    
  </div>
  
  <div class="col-lg-9 navbar-header-items">
    
    <div class="me-auto navbar-header-items__center">
      
        <div class="navbar-item">
<nav>
  <ul class="bd-navbar-elements navbar-nav">
    
<li class="nav-item ">
  <a class="nav-link nav-internal" href="../GetStarted/index.html">
    Get Started
  </a>
</li>


<li class="nav-item ">
  <a class="nav-link nav-internal" href="../UserGuide/index.html">
    User Guide
  </a>
</li>


<li class="nav-item current active">
  <a class="nav-link nav-internal" href="index.html">
    Tutorials
  </a>
</li>


<li class="nav-item ">
  <a class="nav-link nav-internal" href="../API/index.html">
    API
  </a>
</li>

  </ul>
</nav></div>
      
    </div>
    
    
    <div class="navbar-header-items__end">
      
        <div class="navbar-item navbar-persistent--container">
          

<button class="btn search-button-field search-button__button pst-js-only" title="Search" aria-label="Search" data-bs-placement="bottom" data-bs-toggle="tooltip">
 <i class="fa-solid fa-magnifying-glass"></i>
 <span class="search-button__default-text">Search</span>
 <span class="search-button__kbd-shortcut"><kbd class="kbd-shortcut__modifier">Ctrl</kbd>+<kbd class="kbd-shortcut__modifier">K</kbd></span>
</button>
        </div>
      
      
        <div class="navbar-item">

<button class="btn btn-sm nav-link pst-navbar-icon theme-switch-button pst-js-only" aria-label="Color mode" data-bs-title="Color mode"  data-bs-placement="bottom" data-bs-toggle="tooltip">
  <i class="theme-switch fa-solid fa-sun                fa-lg" data-mode="light" title="Light"></i>
  <i class="theme-switch fa-solid fa-moon               fa-lg" data-mode="dark"  title="Dark"></i>
  <i class="theme-switch fa-solid fa-circle-half-stroke fa-lg" data-mode="auto"  title="System Settings"></i>
</button></div>
      
        <div class="navbar-item"><ul class="navbar-icon-links"
    aria-label="Icon Links">
        <li class="nav-item">
          
          
          
          
          
          
          
          
          <a href="<https://gitlab.eclipse.org/eclipse/aidge>" title="GitLab" class="nav-link pst-navbar-icon" rel="noopener" target="_blank" data-bs-toggle="tooltip" data-bs-placement="bottom"><i class="fab fa-gitlab fa-lg" aria-hidden="true"></i>
            <span class="sr-only">GitLab</span></a>
        </li>
</ul></div>
      
    </div>
    
  </div>
  
  
    <div class="navbar-persistent--mobile">

<button class="btn search-button-field search-button__button pst-js-only" title="Search" aria-label="Search" data-bs-placement="bottom" data-bs-toggle="tooltip">
 <i class="fa-solid fa-magnifying-glass"></i>
 <span class="search-button__default-text">Search</span>
 <span class="search-button__kbd-shortcut"><kbd class="kbd-shortcut__modifier">Ctrl</kbd>+<kbd class="kbd-shortcut__modifier">K</kbd></span>
</button>
    </div>
  

  
    <button class="pst-navbar-icon sidebar-toggle secondary-toggle" aria-label="On this page">
      <span class="fa-solid fa-outdent"></span>
    </button>
  
</div>

    </header>
  

  <div class="bd-container">
    <div class="bd-container__inner bd-page-width">
      
      
      
      <dialog id="pst-primary-sidebar-modal"></dialog>
      <div id="pst-primary-sidebar" class="bd-sidebar-primary bd-sidebar">
        

  
  <div class="sidebar-header-items sidebar-primary__section">
    
    
      <div class="sidebar-header-items__center">
        
          
          
            <div class="navbar-item">
<nav>
  <ul class="bd-navbar-elements navbar-nav">
    
<li class="nav-item ">
  <a class="nav-link nav-internal" href="../GetStarted/index.html">
    Get Started
  </a>
</li>


<li class="nav-item ">
  <a class="nav-link nav-internal" href="../UserGuide/index.html">
    User Guide
  </a>
</li>


<li class="nav-item current active">
  <a class="nav-link nav-internal" href="index.html">
    Tutorials
  </a>
</li>


<li class="nav-item ">
  <a class="nav-link nav-internal" href="../API/index.html">
    API
  </a>
</li>

  </ul>
</nav></div>
          
        
      </div>
    
    
    
      <div class="sidebar-header-items__end">
        
          <div class="navbar-item">

<button class="btn btn-sm nav-link pst-navbar-icon theme-switch-button pst-js-only" aria-label="Color mode" data-bs-title="Color mode"  data-bs-placement="bottom" data-bs-toggle="tooltip">
  <i class="theme-switch fa-solid fa-sun                fa-lg" data-mode="light" title="Light"></i>
  <i class="theme-switch fa-solid fa-moon               fa-lg" data-mode="dark"  title="Dark"></i>
  <i class="theme-switch fa-solid fa-circle-half-stroke fa-lg" data-mode="auto"  title="System Settings"></i>
</button></div>
        
          <div class="navbar-item"><ul class="navbar-icon-links"
    aria-label="Icon Links">
        <li class="nav-item">
          
          
          
          
          
          
          
          
          <a href="<https://gitlab.eclipse.org/eclipse/aidge>" title="GitLab" class="nav-link pst-navbar-icon" rel="noopener" target="_blank" data-bs-toggle="tooltip" data-bs-placement="bottom"><i class="fab fa-gitlab fa-lg" aria-hidden="true"></i>
            <span class="sr-only">GitLab</span></a>
        </li>
</ul></div>
        
      </div>
    
  </div>
  
    <div class="sidebar-primary-items__start sidebar-primary__section">
        <div class="sidebar-primary-item">
<nav class="bd-docs-nav bd-links"
     aria-label="Section Navigation">
  <p class="bd-links__title" role="heading" aria-level="1">Section Navigation</p>
  <div class="bd-toc-item navbar-nav"><ul class="current nav bd-sidenav">
<li class="toctree-l1 current active"><a class="current reference internal" href="#">Aidge demonstration</a></li>
</ul>
<ul class="nav bd-sidenav">
<li class="toctree-l1"><a class="reference internal" href="database.html">Database MNIST</a></li>
<li class="toctree-l1"><a class="reference internal" href="graph_matching.html">Graph matching and manipulation with Aidge</a></li>
<li class="toctree-l1"><a class="reference internal" href="scheduling.html">Understanding Aidge’s scheduling</a></li>
<li class="toctree-l1"><a class="reference internal" href="learning.html">Training a simple Neural Network</a></li>
<li class="toctree-l1"><a class="reference internal" href="ONNX.html">Aidge ONNX tutorial</a></li>
</ul>
<ul class="nav bd-sidenav">
<li class="toctree-l1"><a class="reference internal" href="ptq.html">Post Training Quantization with AIDGE</a></li>
<li class="toctree-l1"><a class="reference internal" href="tiling.html">Aidge tiling demonstration</a></li>
</ul>
<ul class="nav bd-sidenav">
<li class="toctree-l1"><a class="reference internal" href="export_cpp.html">Export a MNIST model to a CPP standalone project</a></li>
</ul>
</div>
</nav></div>
    </div>
  
  
  <div class="sidebar-primary-items__end sidebar-primary__section">
      <div class="sidebar-primary-item">
<div id="ethical-ad-placement"
      class="flat"
      data-ea-publisher="readthedocs"
      data-ea-type="readthedocs-sidebar"
      data-ea-manual="true">
</div></div>
  </div>


      </div>
      
      <main id="main-content" class="bd-main" role="main">
        
        
          <div class="bd-content">
            <div class="bd-article-container">
              
              <div class="bd-header-article d-print-none">
<div class="header-article-items header-article__inner">
  
    <div class="header-article-items__start">
      
        <div class="header-article-item">

<nav aria-label="Breadcrumb" class="d-print-none">
  <ul class="bd-breadcrumbs">
    
    <li class="breadcrumb-item breadcrumb-home">
      <a href="../../index.html" class="nav-link" aria-label="Home">
        <i class="fa-solid fa-home"></i>
      </a>
    </li>
    
    <li class="breadcrumb-item"><a href="index.html" class="nav-link">Tutorials</a></li>
    
    <li class="breadcrumb-item active" aria-current="page"><span class="ellipsis">Aidge demonstration</span></li>
  </ul>
</nav>
</div>
      
    </div>
  
  
</div>
</div>
              
              
              
                
<div id="searchbox"></div>
                <article class="bd-article">
                  
  <section id="Aidge-demonstration">
<h1>Aidge demonstration<a class="headerlink" href="#Aidge-demonstration" title="Link to this heading">#</a></h1>
<p>Aidge is a collaborative <strong>open source deep learning library</strong> optimized for exporting and processing deep learning algorithms on <strong>embedded devices</strong>. With Aidge, one you can create or import a <em>computational graph</em> from popular frameworks, apply modification to its structure, train it and export its architecture to various embedded devices. Aidge provides optimized functions for both inference and training, as well as many custom functionalities for the target device.</p>
<p>This notebook put in perspective the tool chain to import a Deep Neural Network from ONNX model and support its Inference in Aidge. The tool chain demonstrated is:</p>
<p><img alt="pipeline(0)" src="../../_images/pipeline0.png" /></p>
<p>In order to demonstrate this toolchain, the MNIST digit recognition task is used.</p>
<p><img alt="MNIST" src="../../_images/MnistExamples.png" /></p>
<section id="Setting-up-the-notebook">
<h2>Setting up the notebook<a class="headerlink" href="#Setting-up-the-notebook" title="Link to this heading">#</a></h2>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[1]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="c1"># First import some utility methods used in the tutorial:</span>
<span class="kn">import</span><span class="w"> </span><span class="nn">sys</span><span class="o">,</span><span class="w"> </span><span class="nn">os</span>
<span class="n">sys</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">abspath</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="s1">&#39;..&#39;</span><span class="p">)))</span>
<span class="kn">import</span><span class="w"> </span><span class="nn">tuto_utils</span>
</pre></div>
</div>
</div>
<section id="(if-needed)-Download-the-model">
<h3>(if needed) Download the model<a class="headerlink" href="#(if-needed)-Download-the-model" title="Link to this heading">#</a></h3>
<p>If you don’t have git-lfs, you can download the model and data using this piece of code</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[2]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="c1"># Download onnx model file</span>
<span class="n">tuto_utils</span><span class="o">.</span><span class="n">download_material</span><span class="p">(</span><span class="s2">&quot;101_first_step&quot;</span><span class="p">,</span> <span class="s2">&quot;MLP_MNIST.onnx&quot;</span><span class="p">)</span>
<span class="c1"># Download input data</span>
<span class="n">tuto_utils</span><span class="o">.</span><span class="n">download_material</span><span class="p">(</span><span class="s2">&quot;101_first_step&quot;</span><span class="p">,</span> <span class="s2">&quot;input_digit.npy&quot;</span><span class="p">)</span>
<span class="c1"># Download output data for later comparison</span>
<span class="n">tuto_utils</span><span class="o">.</span><span class="n">download_material</span><span class="p">(</span><span class="s2">&quot;101_first_step&quot;</span><span class="p">,</span> <span class="s2">&quot;output_digit.npy&quot;</span><span class="p">)</span>
</pre></div>
</div>
</div>
</section>
</section>
<section id="Import-Aidge">
<h2>Import Aidge<a class="headerlink" href="#Import-Aidge" title="Link to this heading">#</a></h2>
<p>In order to provide a colaborative environnement in the platform, the structure of Aidge is built on a core library that interfaces with multiple modules binded to python libraries.</p>
<ul class="simple">
<li><p>aidge_core is the core library which offers all the basic functionnalities to create and manipulate the internal computational graph representation;</p></li>
<li><p>aidge_backend_cpu is a C++ module providing a generic C++ implementations for each component of the computational graph;</p></li>
<li><p>aidge_onnx is a module allowing to import ONNX to the Aidge framework;</p></li>
<li><p>aidge_export_cpp is a module dedicated to the generation of optimized C++ code.</p></li>
</ul>
<p>This way, aidge_core is free of any dependencies and the user can install whatever they want depending on their use case.</p>
<p><img alt="modular" src="../../_images/modular.png" /></p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[3]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="kn">import</span><span class="w"> </span><span class="nn">aidge_core</span>

<span class="c1"># Conv2D Operator is available but only the &quot;export_serialize&quot; is available.</span>
<span class="c1"># This backend allow to generate C++ code but not to run inference.</span>
<span class="c1"># For this we would need &quot;cpu&quot; backend.</span>
<span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Available backends:</span><span class="se">\n</span><span class="si">{</span><span class="n">aidge_core</span><span class="o">.</span><span class="n">get_keys_Conv2DOp</span><span class="p">()</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">)</span>

<span class="c1"># note: Tensor is a special case as &#39;cpu&#39; backend is provided in the core</span>
<span class="c1"># module to guarantee basic functionalities such as data accesss</span>
<span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Available backends for Tensor:</span><span class="se">\n</span><span class="si">{</span><span class="n">aidge_core</span><span class="o">.</span><span class="n">Tensor</span><span class="o">.</span><span class="n">get_available_backends</span><span class="p">()</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Available backends:
{&#39;export_serialize&#39;}
Available backends for Tensor:
{&#39;cpu&#39;}
</pre></div></div>
</div>
<p>As one can see, only an export backend is available for the class Conv2D, which is <code class="docutils literal notranslate"><span class="pre">export_serialize</span></code>. One needs to import the <code class="docutils literal notranslate"><span class="pre">aidge_backend_cpu</span></code> module which automatically registers itself to <code class="docutils literal notranslate"><span class="pre">aidge_core</span></code>, giving access to a backend that is able to run an inference.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[4]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="kn">import</span><span class="w"> </span><span class="nn">aidge_backend_cpu</span>

<span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Available backends:</span><span class="se">\n</span><span class="si">{</span><span class="n">aidge_core</span><span class="o">.</span><span class="n">get_keys_Conv2DOp</span><span class="p">()</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">)</span>
<br/></pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Available backends:
{&#39;cpu&#39;, &#39;export_serialize&#39;}
</pre></div></div>
</div>
<p>For this tutorial, we will need to import <code class="docutils literal notranslate"><span class="pre">aidge_onnx</span></code> in order to load ONNX files, numpy in order to load data and matplotlib to display images.</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[5]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><br/><span></span><span class="kn">import</span><span class="w"> </span><span class="nn">aidge_onnx</span>
<span class="kn">import</span><span class="w"> </span><span class="nn">numpy</span><span class="w"> </span><span class="k">as</span><span class="w"> </span><span class="nn">np</span>
<span class="kn">import</span><span class="w"> </span><span class="nn">matplotlib.pyplot</span><span class="w"> </span><span class="k">as</span><span class="w"> </span><span class="nn">plt</span>
<br/></pre></div>
</div>
</div>
</section>
<section id="ONNX-Import">
<h2>ONNX Import<a class="headerlink" href="#ONNX-Import" title="Link to this heading">#</a></h2>
<p><img alt="pipeline(1)" src="../../_images/pipeline1.png" /></p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[6]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">model</span> <span class="o">=</span> <span class="n">aidge_onnx</span><span class="o">.</span><span class="n">load_onnx</span><span class="p">(</span><span class="s2">&quot;MLP_MNIST.onnx&quot;</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
<span style="color: rgb(255,165,0)">Warning: an error occured when trying to load node &#39;Flatten&#39; of type flatten.</span>
<span style="color: rgb(255,165,0)">Loading node using a generic operator.</span>
<span style="color: rgb(255,165,0)">Please report this issue at https://gitlab.eclipse.org/eclipse/aidge/aidge_onnx</span>
<span style="color: rgb(255,165,0)">by providing your ONNX model and the following error:</span>
<span style="color: rgb(255,165,0)">ONNX_NODE_CONVERTER_ returned: module &#39;aidge_core&#39; has no attribute &#39;Flatten&#39;</span>
<span style="color: rgb(147,112,219)">- Flatten (Flatten | GenericOperator)</span>
<span style="color: rgb(147,112,219)">  - axis : 1</span>
<span style="color: rgb(147,112,219)">- fc1_Gemm (Gemm)</span>
<span style="color: rgb(147,112,219)">- Relu (Relu)</span>
<span style="color: rgb(147,112,219)">- fc2_Gemm (Gemm)</span>
<span style="color: rgb(147,112,219)">- Relu_1 (Relu)</span>
<span style="color: rgb(147,112,219)">- fc3_Gemm (Gemm)</span>
</pre></div></div>
</div>
<p>As you can see in the logs, aidge imported a Node as a <code class="docutils literal notranslate"><span class="pre">GenericOperator</span></code>:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>- /Flatten_output_0 (Flatten | GenericOperator)
</pre></div>
</div>
<p>This is a fallback mechanism which allows Aidge to load the entirety of an ONNX graph without failing, even when encountering a node that is not yet available in Aidge.</p>
<p>The <code class="docutils literal notranslate"><span class="pre">GenericOperator</span></code> acts as a stub retrieving the node’s type and attributes from ONNX. This allows the user to provide these nodes an implementation in a user script or remove/replace them using Aidge’s recipes, as detailed hereafter. You can visualize the graph using the <code class="docutils literal notranslate"><span class="pre">save</span></code> method and the mermaid visualizer we have setup.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[7]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">model</span><span class="o">.</span><span class="n">save</span><span class="p">(</span><span class="s2">&quot;myModel&quot;</span><span class="p">)</span>
<span class="n">tuto_utils</span><span class="o">.</span><span class="n">visualize_mmd</span><span class="p">(</span><span class="s2">&quot;myModel.mmd&quot;</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area rendered_html docutils container">
<img src="https://mermaid.ink/img/pako:eNqllmGPmjAYx79K04vDSzRSlGxjxhdzcW_2YrlsS5axmArlbFZaU8r04vndr0DBqhy6LCZa-zz_3_9peQrsYSRiAgMAe7095VQFYO8kTGyjNZbK0f-AE-XyL9FDJxVcKMHJT-cwAE4iuFrglLKnIvaDyBhz7IADOPR6IW8Y4NvHkIf8qxRxHhG5dPshTCK03BL6uFbTlRzNplm-mk1JOuvXWXfu_XSkJ6ajIhTC-yAINiY2Z9lSCqH0r4VFBruiOHsNijqhFmxSwsZXapzcihuXOK-ztvGtMM_AumvzbsX5ZqldtflXYAuGlSK8vLRmfIYys22X9ZFwImlUgeZNe3wmaXoOmV_oQ_5AvnwvRQ-E5WeCItYi0S7IbGK7C2p3QcZlidp8UJuPZ3a33ce7kBxPyXA4ew6hC3757gC8fTf5DRZMYDX2SsybGEv5oRyiED4X-2afBUv8qs671E0aHdKmHVrj6dk9_g-eyG7nk4Ve97S1vlXvNU_PalMjO890mx0pvjuSqp6re6-bhqp-u0ZDdY910_QqKN_kyu33aXGaigNUTujjM6yk56J60VU_Di_5OknkqoLqgaFWU-WpjBjOsk8kAbUTSChjwR1OsBVsBCaanETJThHJMTvGoyiy4tb9pIknVvx4l6jx7_UnGWRKij9kuKWxWgdos6snYpzph4_ETwHwgW-BUqJwQTkR-pudlWIeLiZFW7lue6XLlsxBd_Udkv9cUSv5cpUhhwMAUyJTTGP93N9DtSZp-QYQkwTnTMHD4QXSsqsC"/></div>
</div>
</section>
<section id="Graph-transformation">
<h2>Graph transformation<a class="headerlink" href="#Graph-transformation" title="Link to this heading">#</a></h2>
<p><img alt="pipeline(2)" src="../../_images/pipeline2.png" /></p>
<p>In order to support the graph for inference we need to support all operators. The imported model contains <code class="docutils literal notranslate"><span class="pre">Flatten</span></code> before the <code class="docutils literal notranslate"><span class="pre">Gemm</span></code> operator. The <code class="docutils literal notranslate"><span class="pre">aidge.FC</span></code> operator already supports the flatten operation. Graph transformation is required to support the graph for inference, i.e. remove the <code class="docutils literal notranslate"><span class="pre">Flatten</span></code> operator.</p>
<p>Aidge’s graph transformation toolchain is embedded inside <code class="docutils literal notranslate"><span class="pre">recipes</span></code> functions. These recipes are available in <code class="docutils literal notranslate"><span class="pre">aidge_core</span></code>.</p>
<p>Examples include:</p>
<ul class="simple">
<li><p><strong>fuse_batchnorm</strong>: Fuse BatchNorm inside Conv or FC operator;</p></li>
<li><p><strong>matmul_to_fc</strong>: Fuse MatMul and Add operator into a FC operator;</p></li>
<li><p><strong>conv_horizontal_tiling</strong>: replace a conv by an horizontal tilled version;</p></li>
<li><p><strong>remove_flatten</strong>: Remove Flatten if it is before an FC operator;</p></li>
<li><p><strong>adapt_to_backend</strong>: Adapt graph to the current backend by adding Transpose layer to match expected input/output data format;</p></li>
<li><p><strong>constant_folding</strong>: Compute constant part of the graph and replace them by pre-computed values.</p></li>
</ul>
<p>Let’s apply the <strong>remove_flatten</strong> recipe:</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[8]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="c1"># Use the remove_flatten recipe</span>
<span class="n">aidge_core</span><span class="o">.</span><span class="n">remove_flatten</span><span class="p">(</span><span class="n">model</span><span class="p">)</span>
</pre></div>
</div>
</div>
<p>The <code class="docutils literal notranslate"><span class="pre">flatten</span></code> node is removed with the recipie. Let’s visualize the model:</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[9]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">model</span><span class="o">.</span><span class="n">save</span><span class="p">(</span><span class="s2">&quot;mySupportedModel&quot;</span><span class="p">)</span>
<span class="n">tuto_utils</span><span class="o">.</span><span class="n">visualize_mmd</span><span class="p">(</span><span class="s2">&quot;mySupportedModel.mmd&quot;</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area rendered_html docutils container">
<img src="https://mermaid.ink/img/pako:eNqlleGPmjAYxv-VpheHl2ikKLmNGT_MxX3Zh-WyLVmOhVQoZzNoTSnTi8f_fgWqV4UDl8VEsc_7_J63-FYOMOQRgR6Ag8GBMio9cLDihO_CDRbSUt-AFebiL1GXVsoZl5yRX1YxAlbMmVzhlCZPpfaTiAgzbIECFIOBz04M8P2Tz3z2TfAoD4kI7KEP4xAFO0IfN3K-FpPFPMvXizlJF8Nj1Y19O5-ohfmklHx463neVmvLJAsE51J9GliksWuKs7egqBNqwGYVbNrT4-xa3LTCOZ29Ta-FORrW3ZtzLc7VW-3qze2BrZanX_ULSdMLzGrZ-DV9dk--_qhM9yTJLwyl1mJRKUjvvT0FtacgnRKgthzUluPom9Ke4zQsr8M9Hi-efWiDB9cegbv3s99glXAsp06FeRdhIT5Wl8iHz-V9M0fYML_pc5q-2cmHVGiHV2c65mj-QyYyp_Bso_2Zptc1-u3LdOrp0o7LIlsV1ZN0nKiOwrqL8r2Pho6T001TvVG2zaU9HFKmBrY8F9WCOhTj2to02fWAjZtopfNc1jx1oYH1UnXMwgRn2WcSg2MIiGmSeDc4xoZ4Mmg1PlPJXhLBcPKqh2Fo6Ma5PumxoT8SRgQNDfwH9YpHmRT8DxnvaCQ3HtrujwsRztRDQOAnD7jANUApkbiknBnd7d4o0X_yukRF2XZ7p0FL5ai7-w7Lf-6oldzcpc_gCMCUiBTTSD1_D1BuSFo9iSMS4zyRsCheAHnPgzI="/></div>
</div>
</section>
<section id="Static-analysis">
<h2>Static analysis<a class="headerlink" href="#Static-analysis" title="Link to this heading">#</a></h2>
<p><img alt="pipeline(3)" src="../../_images/pipeline3.png" /></p>
<p>Static analysis can be applied anytime on a graph in order to measure its complexity in terms of memory and operations.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[10]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="kn">import</span><span class="w"> </span><span class="nn">aidge_core.static_analysis</span>

<span class="c1"># Dims must be forwarded for static analysis!</span>
<span class="n">model</span><span class="o">.</span><span class="n">forward_dims</span><span class="p">(</span><span class="n">dims</span><span class="o">=</span><span class="p">[[</span><span class="mi">1</span><span class="p">,</span> <span class="mi">1</span><span class="p">,</span> <span class="mi">28</span><span class="p">,</span> <span class="mi">28</span><span class="p">]],</span> <span class="n">allow_data_dependency</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>

<span class="n">model_stats</span> <span class="o">=</span> <span class="n">aidge_core</span><span class="o">.</span><span class="n">static_analysis</span><span class="o">.</span><span class="n">StaticAnalysisExt</span><span class="p">(</span><span class="n">model</span><span class="p">)</span>
<span class="n">model_stats</span><span class="o">.</span><span class="n">summary</span><span class="p">()</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
--------------------------------------------------------------------------------
                        Layer (type)               Output Shape         Param #
================================================================================
                     fc1_Gemm (FC#0)                    [1, 50]           39250
                       Relu (ReLU#0)                    [1, 50]               0
                     fc2_Gemm (FC#1)                    [1, 50]            2550
                     Relu_1 (ReLU#1)                    [1, 50]               0
                     fc3_Gemm (FC#2)                    [1, 10]             510
================================================================================
Total params: 42310
--------------------------------------------------------------------------------
Input size (MB): 0.00299072265625
Forward/backward pass size (MB): 0.00080108642578125
Params size (MB): 0.16139984130859375
Estimated Total Size (MB): 0.165191650390625
--------------------------------------------------------------------------------
</pre></div></div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[11]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">model_stats</span><span class="o">.</span><span class="n">log_nb_ops_by_type</span><span class="p">(</span><span class="s2">&quot;stats_ops.png&quot;</span><span class="p">,</span> <span class="n">log_scale</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
<br/></pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[11]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
[[&#39;fc1_Gemm (FC#0)&#39;, [0, 78400, 0, 0, 0]],
 [&#39;Relu (ReLU#0)&#39;, [0, 0, 0, 50, 0]],
 [&#39;fc2_Gemm (FC#1)&#39;, [0, 5000, 0, 0, 0]],
 [&#39;Relu_1 (ReLU#1)&#39;, [0, 0, 0, 50, 0]],
 [&#39;fc3_Gemm (FC#2)&#39;, [0, 1000, 0, 0, 0]]]
</pre></div></div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../../_images/source_Tutorial_101_first_step_21_1.png" src="../../_images/source_Tutorial_101_first_step_21_1.png" />
</div>
</div>
</section>
<section id="Inference">
<h2>Inference<a class="headerlink" href="#Inference" title="Link to this heading">#</a></h2>
<p><img alt="pipeline(4)" src="../../_images/pipeline4.png" /></p>
<section id="Create-an-input-tensor">
<h3>Create an input tensor<a class="headerlink" href="#Create-an-input-tensor" title="Link to this heading">#</a></h3>
<p>In order to perform an inference pass, we will load an image from the MNIST dataset using Numpy.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[12]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="c1">## Load input data &amp; its output from the MNIST_model</span>
<span class="n">digit</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="s2">&quot;input_digit.npy&quot;</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">imshow</span><span class="p">(</span><span class="n">digit</span><span class="p">[</span><span class="mi">0</span><span class="p">][</span><span class="mi">0</span><span class="p">],</span> <span class="n">cmap</span><span class="o">=</span><span class="s1">&#39;gray&#39;</span><span class="p">)</span>
<br/></pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[12]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
&lt;matplotlib.image.AxesImage at 0x7fac1c1bf550&gt;
</pre></div></div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../../_images/source_Tutorial_101_first_step_23_1.png" src="../../_images/source_Tutorial_101_first_step_23_1.png" />
</div>
</div>
<p>And in order to validate the result our model will provide, we will also load the output the PyTorch model povided for this image</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[13]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">output_model</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="s2">&quot;output_digit.npy&quot;</span><span class="p">)</span>
<span class="nb">print</span><span class="p">(</span><span class="n">output_model</span><span class="p">)</span>
<br/></pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
[[[ -1.3114135  -1.3960878   5.118178    5.338807   -8.182431
    -0.612254  -11.45598    13.0557165  -3.0393667   2.6212344]]]
</pre></div></div>
</div>
<p>Thanks to the Numpy interoperability we can create an Aidge <code class="docutils literal notranslate"><span class="pre">Tensor</span></code> using directly the numpy array storing the image.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[14]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">input_tensor</span> <span class="o">=</span> <span class="n">aidge_core</span><span class="o">.</span><span class="n">Tensor</span><span class="p">(</span><span class="n">digit</span><span class="p">)</span>
<span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Aidge Input Tensor dimensions: </span><span class="se">\n</span><span class="si">{</span><span class="n">input_tensor</span><span class="o">.</span><span class="n">dims</span><span class="p">()</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">)</span>
<br/></pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Aidge Input Tensor dimensions:
[1, 1, 28, 28]
</pre></div></div>
</div>
</section>
<section id="Configure-the-model-for-inference">
<h3>Configure the model for inference<a class="headerlink" href="#Configure-the-model-for-inference" title="Link to this heading">#</a></h3>
<p>At the moment the model has no implementation, it is only a datastructure. To set an implementation we will set a dataype and a backend.</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[15]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="c1"># Configure the model</span>
<span class="n">model</span><span class="o">.</span><span class="n">compile</span><span class="p">(</span><span class="s2">&quot;cpu&quot;</span><span class="p">,</span> <span class="n">aidge_core</span><span class="o">.</span><span class="n">dtype</span><span class="o">.</span><span class="n">float32</span><span class="p">,</span> <span class="n">dims</span><span class="o">=</span><span class="p">[[</span><span class="mi">1</span><span class="p">,</span><span class="mi">1</span><span class="p">,</span><span class="mi">28</span><span class="p">,</span><span class="mi">28</span><span class="p">]])</span>
<span class="c1"># equivalent to set_datatype(), set_backend() and forward_dims()</span>
</pre></div>
</div>
</div>
</section>
<section id="Create-a-scheduler-and-run-inference">
<h3>Create a scheduler and run inference<a class="headerlink" href="#Create-a-scheduler-and-run-inference" title="Link to this heading">#</a></h3>
<p>The graph is ready to run ! We just need to schedule the execution, to do this we will create a <code class="docutils literal notranslate"><span class="pre">Scheduler</span></code> object, which will take the graph and generate an optimized scheduling using a consummer producer heuristic.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[16]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="c1"># Create SCHEDULER</span>
<span class="n">scheduler</span> <span class="o">=</span> <span class="n">aidge_core</span><span class="o">.</span><span class="n">SequentialScheduler</span><span class="p">(</span><span class="n">model</span><span class="p">)</span>

<span class="c1"># Run inference !</span>
<span class="n">scheduler</span><span class="o">.</span><span class="n">forward</span><span class="p">(</span><span class="n">data</span><span class="o">=</span><span class="p">[</span><span class="n">input_tensor</span><span class="p">])</span>
<br/></pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Context: Consumer node fc1_Gemm (FC#0) input #0
<span style="color: rgb(255,165,0)">No producer node attached to input#0 for node fc1_Gemm (FC)
</span>
Context: Consumer node fc1_Gemm (FC#0) input #0
<span style="color: rgb(255,165,0)">No producer node attached to input#0 for node fc1_Gemm (FC)
</span>
</pre></div></div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[17]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="c1"># Assert results</span>
<span class="k">for</span> <span class="n">outNode</span> <span class="ow">in</span> <span class="n">model</span><span class="o">.</span><span class="n">get_output_nodes</span><span class="p">():</span>
    <span class="n">output_aidge</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">outNode</span><span class="o">.</span><span class="n">get_operator</span><span class="p">()</span><span class="o">.</span><span class="n">get_output</span><span class="p">(</span><span class="mi">0</span><span class="p">))</span>
    <span class="nb">print</span><span class="p">(</span><span class="n">output_aidge</span><span class="p">)</span>
    <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;Aidge prediction = &#39;</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">argmax</span><span class="p">(</span><span class="n">output_aidge</span><span class="p">[</span><span class="mi">0</span><span class="p">]))</span>
    <span class="k">assert</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">allclose</span><span class="p">(</span><span class="n">output_aidge</span><span class="p">,</span> <span class="n">output_model</span><span class="p">,</span><span class="n">rtol</span><span class="o">=</span><span class="mf">1e-04</span><span class="p">))</span>
<br/></pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
[[ -1.3114134  -1.3960874   5.1181774   5.3388066  -8.182431   -0.6122534
  -11.455979   13.055716   -3.0393662   2.6212344]]
Aidge prediction =  7
</pre></div></div>
</div>
<p>It is possible to save the scheduling in a mermaid format using:</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[18]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">scheduler</span><span class="o">.</span><span class="n">save_scheduling_diagram</span><span class="p">(</span><span class="s2">&quot;schedulingSequential&quot;</span><span class="p">)</span>
<span class="n">tuto_utils</span><span class="o">.</span><span class="n">visualize_mmd</span><span class="p">(</span><span class="s2">&quot;schedulingSequential.mmd&quot;</span><span class="p">)</span>
<br/></pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area rendered_html docutils container">
<img src="https://mermaid.ink/img/pako:eNplkcFqwzAMhl9FeAwy8MGO7bTpddBddtgKuxmKG6ttoE4gcVih9N0n16GM9mh_-izp94U1vUe2AnZwXYy28y7iuh-Ci3C2nTu343x6_QY7CbEzo-1st2_k9hfbwzFC8TX0fmpweBFvsBIcVMa71o3_oCS44LBMUD27mrCUHKRMBeWjrQiXikOpM37yy1RQUUGVGzz4JuGacJ2H-8AQoFi_32ZWMgESN3iaoNjg50--F_SgFnVueVfSJloSMlpkZytnKyGjqU-l5kXvVhqw0obDwqiUIOPAAlK0raf4LyweMdw-wuPeTafIrtc_A1N66Q=="/></div>
</div>
</section>
</section>
<section id="Optimize-network">
<h2>Optimize network<a class="headerlink" href="#Optimize-network" title="Link to this heading">#</a></h2>
<p><img alt="pipeline(5)" src="../../_images/pipeline5.png" /></p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[19]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">quantized_model</span> <span class="o">=</span> <span class="n">model</span><span class="o">.</span><span class="n">clone</span><span class="p">()</span>
</pre></div>
</div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[20]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="kn">import</span><span class="w"> </span><span class="nn">gzip</span>

<span class="n">NB_SAMPLES</span> <span class="o">=</span> <span class="mi">100</span> <span class="c1"># Number of samples to use for PTQ</span>

<span class="c1"># Use data stored in PTQ tutorial, make sure to download them using git lfs</span>
<span class="n">samples</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">gzip</span><span class="o">.</span><span class="n">GzipFile</span><span class="p">(</span><span class="s1">&#39;../PTQ_tutorial/mnist_samples.npy.gz&#39;</span><span class="p">,</span> <span class="s2">&quot;r&quot;</span><span class="p">))</span>
<span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">10</span><span class="p">):</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">subplot</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="mi">10</span><span class="p">,</span> <span class="n">i</span> <span class="o">+</span> <span class="mi">1</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">axis</span><span class="p">(</span><span class="s1">&#39;off&#39;</span><span class="p">)</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">tight_layout</span><span class="p">()</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">imshow</span><span class="p">(</span><span class="n">samples</span><span class="p">[</span><span class="n">i</span><span class="p">],</span> <span class="n">cmap</span><span class="o">=</span><span class="s1">&#39;gray&#39;</span><span class="p">)</span>

<span class="n">tensors</span> <span class="o">=</span> <span class="p">[]</span>
<span class="k">for</span> <span class="n">sample</span> <span class="ow">in</span> <span class="n">samples</span><span class="p">[</span><span class="mi">0</span><span class="p">:</span><span class="n">NB_SAMPLES</span><span class="p">]:</span>
    <span class="n">sample</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">reshape</span><span class="p">(</span><span class="n">sample</span><span class="p">,</span> <span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="mi">1</span><span class="p">,</span> <span class="mi">28</span><span class="p">,</span> <span class="mi">28</span><span class="p">))</span><span class="o">.</span><span class="n">astype</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">float32</span><span class="p">)</span>
    <span class="n">tensor</span> <span class="o">=</span> <span class="n">aidge_core</span><span class="o">.</span><span class="n">Tensor</span><span class="p">(</span><span class="n">sample</span><span class="p">)</span>
    <span class="n">tensors</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">tensor</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../../_images/source_Tutorial_101_first_step_38_0.png" src="../../_images/source_Tutorial_101_first_step_38_0.png" />
</div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[21]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="kn">import</span><span class="w"> </span><span class="nn">aidge_quantization</span>
<span class="n">aidge_quantization</span><span class="o">.</span><span class="n">quantize_network</span><span class="p">(</span>
    <span class="n">quantized_model</span><span class="p">,</span>
    <span class="mi">8</span><span class="p">,</span>
    <span class="n">tensors</span><span class="p">,</span>
    <span class="n">clipping_mode</span>   <span class="o">=</span> <span class="n">aidge_quantization</span><span class="o">.</span><span class="n">Clipping</span><span class="o">.</span><span class="n">MSE</span><span class="p">,</span>
    <span class="n">no_quantization</span>  <span class="o">=</span> <span class="kc">False</span><span class="p">,</span>
    <span class="n">optimize_signs</span>  <span class="o">=</span> <span class="kc">True</span><span class="p">,</span>
    <span class="n">single_shift</span>    <span class="o">=</span> <span class="kc">False</span><span class="p">,</span>
    <span class="n">use_cuda</span>        <span class="o">=</span> <span class="kc">False</span><span class="p">)</span>
<br/></pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
 === QUANT PTQ 0.2.21 ===
 Preparing the network for the PTQ ...
 Inserting the scaling nodes ...
<span style="color: rgb(147,112,219)">Notice: the 0-th Parent of the child node Relu (of type ReLU) already existed</span>
<span style="color: rgb(147,112,219)">Filling a Tensor already attributed.</span>
<span style="color: rgb(147,112,219)">You are replacing an existing parent for node Relu (of type ReLU).</span>
<span style="color: rgb(147,112,219)">Notice: the 0-th Parent of the child node Relu_1 (of type ReLU) already existed</span>
<span style="color: rgb(147,112,219)">Filling a Tensor already attributed.</span>
<span style="color: rgb(147,112,219)">You are replacing an existing parent for node Relu_1 (of type ReLU).</span>
 Applying the Cross-Layer Equalization ...
 Normalizing the parameters ...
 Computing the value ranges ...
Context: Consumer node fc1_Gemm (FC#0) input #0
<span style="color: rgb(255,165,0)">No producer node attached to input#0 for node fc1_Gemm (FC)
</span>
Context: Consumer node fc1_Gemm (FC#0) input #0
<span style="color: rgb(255,165,0)">No producer node attached to input#0 for node fc1_Gemm (FC)
</span>
 Optimizing the clipping values ...
Context: Consumer node fc1_Gemm (FC#0) input #0
<span style="color: rgb(255,165,0)">No producer node attached to input#0 for node fc1_Gemm (FC)
</span>
Context: Consumer node fc1_Gemm (FC#0) input #0
<span style="color: rgb(255,165,0)">No producer node attached to input#0 for node fc1_Gemm (FC)
</span>
Context: Consumer node fc1_Gemm (FC#0) input #0
<span style="color: rgb(255,165,0)">No producer node attached to input#0 for node fc1_Gemm (FC)
</span>
Context: Consumer node fc1_Gemm (FC#0) input #0
<span style="color: rgb(255,165,0)">No producer node attached to input#0 for node fc1_Gemm (FC)
</span>
 Normalizing the activations ...
Context: Consumer node fc1_Gemm (FC#0) input #0
<span style="color: rgb(255,165,0)">No producer node attached to input#0 for node fc1_Gemm (FC)
</span>
Context: Consumer node fc1_Gemm (FC#0) input #0
<span style="color: rgb(255,165,0)">No producer node attached to input#0 for node fc1_Gemm (FC)
</span>
Context: Consumer node fc1_Gemm (FC#0) input #0
<span style="color: rgb(255,165,0)">No producer node attached to input#0 for node fc1_Gemm (FC)
</span>
Context: Consumer node fc1_Gemm (FC#0) input #0
<span style="color: rgb(255,165,0)">No producer node attached to input#0 for node fc1_Gemm (FC)
</span>
 Quantizing the normalized network ...
Context: Consumer node fc1_Gemm (FC#0) input #0
<span style="color: rgb(255,165,0)">No producer node attached to input#0 for node fc1_Gemm (FC)
</span>
Context: Consumer node fc1_Gemm (FC#0) input #0
<span style="color: rgb(255,165,0)">No producer node attached to input#0 for node fc1_Gemm (FC)
</span>
Context: Consumer node fc1_Gemm (FC#0) input #0
<span style="color: rgb(255,165,0)">No producer node attached to input#0 for node fc1_Gemm (FC)
</span>
Context: Consumer node fc1_Gemm (FC#0) input #0
<span style="color: rgb(255,165,0)">No producer node attached to input#0 for node fc1_Gemm (FC)
</span>
Context: Consumer node fc1_Gemm (FC#0) input #0
<span style="color: rgb(255,165,0)">No producer node attached to input#0 for node fc1_Gemm (FC)
</span>
Context: Consumer node fc1_Gemm (FC#0) input #0
<span style="color: rgb(255,165,0)">No producer node attached to input#0 for node fc1_Gemm (FC)
</span>
<span style="color: rgb(147,112,219)">Notice: the 0-th Parent of the child node Relu (of type ReLU) already existed</span>
<span style="color: rgb(147,112,219)">Filling a Tensor already attributed.</span>
<span style="color: rgb(147,112,219)">You are replacing an existing parent for node Relu (of type ReLU).</span>
<span style="color: rgb(147,112,219)">Notice: the 0-th Parent of the child node Relu_1 (of type ReLU) already existed</span>
<span style="color: rgb(147,112,219)">Filling a Tensor already attributed.</span>
<span style="color: rgb(147,112,219)">You are replacing an existing parent for node Relu_1 (of type ReLU).</span>
 Reseting the scheduler ...
 Network is quantized !
</pre></div></div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[22]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">quantized_model</span><span class="o">.</span><span class="n">save</span><span class="p">(</span><span class="s2">&quot;quantizedModel&quot;</span><span class="p">)</span>
<span class="n">tuto_utils</span><span class="o">.</span><span class="n">visualize_mmd</span><span class="p">(</span><span class="s2">&quot;quantizedModel.mmd&quot;</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area rendered_html docutils container">
<img src="https://mermaid.ink/img/pako:eNqlVm1vmzAQ_isWVUYqJSp2QtexKB_WKfuyD133Ik1jilwwDRqYyJi1XZr_PmMMMQnlZVOUhPjueZ67813sneElPjEcYIxGu5CG3AE7M4iSB2-DGTfFL2B6GftNxKMZJzThCSXfzf0EmEFC-QrHYfSU274R5mOKTbAH-9HIpRUH-PLOpS69YYmfeYStrbFrBB5cP5DwfsMXd-xiuUizu-WCxMtx6XVmnS8uxMLiIje5xrnjOFtlu47SNUsSLr41WiRpUQctaqV16acMUx7-0cL8QOJ4_dnDUUjvj1gr56ZoY8LxESVUIfaihL0oi6xn_ShRC2VVx7libK_jvKOOFd1M5XwX4vQlsllfMqj2pI0M9iWzVaJtZHYH2eq61idHNKvrk8Zw6S35-FWCbkmUHQFyWwNEqOitc6oCm1WgUlnDJh3YpKP306kOOoEcpno6XT67hgV-2NYEvL6a_wSrKMF8hiTNKx8z9lY-Qtd4zuumz24NbFtdWFgbVAU-9rWEb1Hs2gx2eUN9Fqq4YK-4kN74Wk4v4lCVz6HHB-D0GtparF04VHTuAdGaXF4ardxlCw9AFynmn_8kCct-HiZZZIl0EOwrKbAh3WbcGo9DKkYyn3y5IMZ-WjAWhBOArvJ3VzCWIoSSEDYRHvVTreTSFUks6sCiRuxMYmeDdKHCziV2Pki3xNoSaw_SLYt_KbGXg3RR7XScnk678E4yXmyteFB7WyzJ_3Qvwmn6ngSglARBGEXOGQ6wZqwAyhrUrOSRE0ZxdLB7nqfZtUOksgea_Z5QwkJPo38jXsEk5Sz5RaYPoc83Dtw-lgs-TsVVi-EnB9jA1ojU-Q5qQHv7qLmoq5RyEVKW1RzpusFz0h59C-Q_M2pkPs3SpcYEGDFhMQ59ccvdGXxDYnnf9UmAs4gb-_1f5TuepQ=="/></div>
</div>
</section>
<section id="Export">
<h2>Export<a class="headerlink" href="#Export" title="Link to this heading">#</a></h2>
<p>Now that we have tested the imported graph we can look at one of the main feature of Aidge, the export of computationnal graph to an hardware target using code generation.</p>
<p><img alt="pipeline(6)" src="../../_images/pipeline6.png" /></p>
<section id="Generate-an-export-in-C++">
<h3>Generate an export in C++<a class="headerlink" href="#Generate-an-export-in-C++" title="Link to this heading">#</a></h3>
<p>In this example we will generate a generic C++ export. This export is not based on the <code class="docutils literal notranslate"><span class="pre">cpu</span></code> backend we have set before.</p>
<p>In this example we will create a standalone export which is abstracted from the Aidge platform.</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[23]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="o">!</span><span class="w"> </span>rm<span class="w"> </span>-r<span class="w"> </span>myexport
<br/></pre></div>
</div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[24]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="o">!</span>ls<span class="w"> </span>myexport
<br/></pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
ls: cannot access &#39;myexport&#39;: No such file or directory
</pre></div></div>
</div>
<p>Generating a <code class="docutils literal notranslate"><span class="pre">cpu</span></code> export recquires the <code class="docutils literal notranslate"><span class="pre">aidge_export_cpp</span></code> module.</p>
<p>Once the module is imported you just need one line to generate an export of the graph.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[29]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="kn">import</span><span class="w"> </span><span class="nn">aidge_export_cpp</span>

<span class="c1"># Configuration for the model + forward dimensions</span>
<span class="n">model</span><span class="o">.</span><span class="n">compile</span><span class="p">(</span><span class="s2">&quot;cpu&quot;</span><span class="p">,</span> <span class="n">aidge_core</span><span class="o">.</span><span class="n">dtype</span><span class="o">.</span><span class="n">float32</span><span class="p">,</span> <span class="n">dims</span><span class="o">=</span><span class="p">[[</span><span class="mi">1</span><span class="p">,</span> <span class="mi">1</span><span class="p">,</span> <span class="mi">28</span><span class="p">,</span> <span class="mi">28</span><span class="p">]])</span>
<span class="c1"># Export the model in C++ standalone</span>
<span class="n">aidge_core</span><span class="o">.</span><span class="n">export_utils</span><span class="o">.</span><span class="n">scheduler_export</span><span class="p">(</span>
        <span class="n">scheduler</span><span class="p">,</span>
        <span class="s2">&quot;myexport&quot;</span><span class="p">,</span>
        <span class="n">aidge_export_cpp</span><span class="o">.</span><span class="n">ExportLibCpp</span><span class="p">,</span>
        <span class="n">memory_manager</span><span class="o">=</span><span class="n">aidge_core</span><span class="o">.</span><span class="n">mem_info</span><span class="o">.</span><span class="n">generate_optimized_memory_info</span><span class="p">,</span>
        <span class="n">memory_manager_args</span><span class="o">=</span><span class="p">{</span><span class="s2">&quot;stats_folder&quot;</span><span class="p">:</span> <span class="s2">&quot;myexport/stats&quot;</span><span class="p">,</span> <span class="s2">&quot;wrapping&quot;</span><span class="p">:</span> <span class="kc">False</span> <span class="p">}</span>
<span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
<span style="color: rgb(147,112,219)">Generated memory management info at: myexport/stats/memory_info.png</span>
</pre></div></div>
</div>
<p>The <code class="docutils literal notranslate"><span class="pre">export_scheduler</span></code> function will generate:</p>
<ul class="simple">
<li><p><strong>dnn/include/forward.hpp</strong> define API function to use the export;</p></li>
<li><p><strong>dnn/include/kernels</strong> folders for kernels;</p></li>
<li><p><strong>dnn/include/layers</strong> layers configuration;</p></li>
<li><p><strong>dnn/include/parameters</strong> folder with parameters;</p></li>
<li><p><strong>dnn/src/forward.cpp</strong> source code of forward function which call kernels;</p></li>
<li><p><strong>Makefile</strong> To compile the main.cpp</p></li>
</ul>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[30]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="o">!</span>tree<span class="w"> </span>myexport
<br/></pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
/bin/bash: line 1: tree: command not found
</pre></div></div>
</div>
</section>
<section id="Generate-main-file">
<h3>Generate main file<a class="headerlink" href="#Generate-main-file" title="Link to this heading">#</a></h3>
<p>Export scheduler only generates the export of the kernels and a forward function which calls the kernels in the order described by the scheduler.</p>
<p>From this point we can start building an application. In order to do so, Aidge proposes a utils function named <code class="docutils literal notranslate"><span class="pre">generate_main_cpp</span></code>, which generates a simple main.cpp, able to perform an inference pass based on an input tensor provided by the user.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[31]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">aidge_core</span><span class="o">.</span><span class="n">export_utils</span><span class="o">.</span><span class="n">generate_main_cpp</span><span class="p">(</span><span class="s2">&quot;myexport&quot;</span><span class="p">,</span> <span class="n">model</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
gen : myexport/fc1_Gemm_input_0.h
</pre></div></div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[32]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="o">!</span>cat<span class="w"> </span>myexport/main.cpp
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>

#include &lt;iostream&gt;
#include &#34;forward.hpp&#34;

#include &#34;fc1_Gemm_input_0.h&#34;




int main()
{
    // Initialize the output arrays
    float* fc3_Gemm_output_0 = nullptr;


    // Call the forward function
    model_forward(fc1_Gemm_input_0, &amp;fc3_Gemm_output_0);

    // Print the results of each output
    printf(&#34;fc3_Gemm_output_0:\n&#34;);
    for (int o = 0; o &lt; 10; ++o) {
        printf(&#34;%f &#34;, fc3_Gemm_output_0[o]);
    }
    printf(&#34;\n&#34;);

    return 0;
}
</pre></div></div>
</div>
</section>
<section id="(Optional)-Generate-an-input-file-for-tests">
<h3>(Optional) Generate an input file for tests<a class="headerlink" href="#(Optional)-Generate-an-input-file-for-tests" title="Link to this heading">#</a></h3>
<p>To test the export we need to provide input data. The <code class="docutils literal notranslate"><span class="pre">generate_main_cpp</span></code> function automatically generates an input file using tensor set as an input.</p>
<p>This is the case here, has we set an input tensor when running the forward pass, so we don’t need to execute the following cell. However, if no input has been set you need to manually generate the input file, to do so we can export a Numpy array using:</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="n">aidge_core</span><span class="o">.</span><span class="n">export_utils</span><span class="o">.</span><span class="n">generate_input_file</span><span class="p">(</span><span class="n">export_folder</span><span class="o">=</span><span class="s2">&quot;myexport&quot;</span><span class="p">,</span> <span class="n">array_name</span><span class="o">=</span><span class="s2">&quot;fc1_Gemm_input_0&quot;</span><span class="p">,</span> <span class="n">tensor</span><span class="o">=</span><span class="n">aidge_core</span><span class="o">.</span><span class="n">Tensor</span><span class="p">(</span><span class="n">digit</span><span class="o">.</span><span class="n">reshape</span><span class="p">(</span><span class="o">-</span><span class="mi">1</span><span class="p">)))</span>
</pre></div>
</div>
</section>
<section id="Compile-the-export">
<h3>Compile the export<a class="headerlink" href="#Compile-the-export" title="Link to this heading">#</a></h3>
<p>Once the generation has been done, we can compile the export with a simple make command:</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[33]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="o">!</span><span class="nb">cd</span><span class="w"> </span>myexport<span class="w"> </span><span class="o">&amp;&amp;</span><span class="w"> </span>make
<br/></pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
g++  -O2 -Wall -Wextra -MMD -fopenmp -I. -I./dnn -I./dnn/include -I./dnn/layers -I./dnn/parameters -c main.cpp -o build/./main.o
g++  -O2 -Wall -Wextra -MMD -fopenmp -I. -I./dnn -I./dnn/include -I./dnn/layers -I./dnn/parameters -c dnn/src/forward.cpp -o build/./dnn/src/forward.o
g++  build/./main.o  build/./dnn/src/forward.o  -fopenmp -o bin/run_export
</pre></div></div>
</div>
</section>
<section id="Run-the-export">
<h3>Run the export<a class="headerlink" href="#Run-the-export" title="Link to this heading">#</a></h3>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[34]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="o">!</span>./myexport/bin/run_export
<br/></pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
fc3_Gemm_output_0:
-1.311413 -1.396087 5.118177 5.338807 -8.182431 -0.612253 -11.455979 13.055716 -3.039366 2.621234
</pre></div></div>
</div>
</section>
</section>
</section>


                </article>
              
              
              
              
              
                <footer class="prev-next-footer d-print-none">
                  
<div class="prev-next-area">
    <a class="left-prev"
       href="index.html"
       title="previous page">
      <i class="fa-solid fa-angle-left"></i>
      <div class="prev-next-info">
        <p class="prev-next-subtitle">previous</p>
        <p class="prev-next-title">Tutorials</p>
      </div>
    </a>
    <a class="right-next"
       href="database.html"
       title="next page">
      <div class="prev-next-info">
        <p class="prev-next-subtitle">next</p>
        <p class="prev-next-title">Database MNIST</p>
      </div>
      <i class="fa-solid fa-angle-right"></i>
    </a>
</div>
                </footer>
              
            </div>
            
            
              
                <dialog id="pst-secondary-sidebar-modal"></dialog>
                <div id="pst-secondary-sidebar" class="bd-sidebar-secondary bd-toc"><div class="sidebar-secondary-items sidebar-secondary__inner">


  <div class="sidebar-secondary-item">
<div
    id="pst-page-navigation-heading-2"
    class="page-toc tocsection onthispage">
    <i class="fa-solid fa-list"></i> On this page
  </div>
  <nav class="bd-toc-nav page-toc" aria-labelledby="pst-page-navigation-heading-2">
    <ul class="visible nav section-nav flex-column">
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#Setting-up-the-notebook">Setting up the notebook</a><ul class="visible nav section-nav flex-column">
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#(if-needed)-Download-the-model">(if needed) Download the model</a></li>
</ul>
</li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#Import-Aidge">Import Aidge</a></li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#ONNX-Import">ONNX Import</a></li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#Graph-transformation">Graph transformation</a></li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#Static-analysis">Static analysis</a></li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#Inference">Inference</a><ul class="visible nav section-nav flex-column">
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#Create-an-input-tensor">Create an input tensor</a></li>
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#Configure-the-model-for-inference">Configure the model for inference</a></li>
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#Create-a-scheduler-and-run-inference">Create a scheduler and run inference</a></li>
</ul>
</li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#Optimize-network">Optimize network</a></li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#Export">Export</a><ul class="visible nav section-nav flex-column">
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#Generate-an-export-in-C++">Generate an export in C++</a></li>
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#Generate-main-file">Generate main file</a></li>
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#(Optional)-Generate-an-input-file-for-tests">(Optional) Generate an input file for tests</a></li>
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#Compile-the-export">Compile the export</a></li>
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#Run-the-export">Run the export</a></li>
</ul>
</li>
</ul>
  </nav></div>

  <div class="sidebar-secondary-item">

  
  <div class="tocsection editthispage">
    <a href="https://gitlab.eclipse.org/eclipse/aidge/aidge/-/edit/master/docs/source/Tutorial/101_first_step.nblink">
      <i class="fa-solid fa-pencil"></i>
      
      
        
          Edit on GitLab
        
      
    </a>
  </div>
</div>

  <div class="sidebar-secondary-item">
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="../../_sources/source/Tutorial/101_first_step.nblink.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div></div>

</div></div>
              
            
          </div>
          <footer class="bd-footer-content">
            
          </footer>
        
      </main>
    </div>
  </div>
  
  <!-- Scripts loaded after <body> so the DOM is not blocked -->
  <script defer src="../../_static/scripts/bootstrap.js?digest=8878045cc6db502f8baf"></script>
<script defer src="../../_static/scripts/pydata-sphinx-theme.js?digest=8878045cc6db502f8baf"></script>

  <footer class="bd-footer">
<div class="bd-footer__inner bd-page-width">
  
    <div class="footer-items__start">
      
        <div class="footer-item">

  <p class="copyright">
    
      © Copyright 2023, CEA LIST.
      <br/>
    
  </p>
</div>
      
        <div class="footer-item">

  <p class="sphinx-version">
    Created using <a href="https://www.sphinx-doc.org/">Sphinx</a> 8.1.3.
    <br/>
  </p>
</div>
      
    </div>
  
  
  
    <div class="footer-items__end">
      
        <div class="footer-item">
<p class="theme-version">
  <!-- # L10n: Setting the PST URL as an argument as this does not need to be localized -->
  Built with the <a href="https://pydata-sphinx-theme.readthedocs.io/en/stable/index.html">PyData Sphinx Theme</a> 0.16.1.
</p></div>
      
    </div>
  
</div>

  </footer>
  </body>
</html>